{
  description = "Yama and Datman";

  inputs = {
    utils.url = "github:numtide/flake-utils";
    naersk.url = "github:nix-community/naersk";
  };

  outputs = { self, nixpkgs, utils, naersk }:
    utils.lib.eachDefaultSystem (system: let
      pkgs = nixpkgs.legacyPackages."${system}";
      naersk-lib = naersk.lib."${system}";
    in rec {
      # `nix build`
      packages.yama = naersk-lib.buildPackage {
        pname = "yama";
        root = ./.;

        buildInputs = with pkgs; [
          openssl
          pkgconfig
          sqlite
        ];
      };

      defaultPackage = packages.yama;

      # NixOS Modules
#       nixosModules = {
#         yama = import ./nixos_modules/yama.nix self;
#       };

      # `nix run`
      apps.yama = utils.lib.mkApp {
        drv = packages.yama;
      };
      defaultApp = apps.yama;

      # `nix develop`
      devShell = pkgs.mkShell {
        nativeBuildInputs = with pkgs; [ rustc cargo ];
      };
    });
}
